#include <stdarg.h>
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <math.h>

void LSE(float *y, float *x, int num, float *beta, float *offset, float *stderror)
{
    float my = 0, mx = 0;
    int i, j;

    for (i=0; i<num; i++) {
	mx += x[i];
	my += y[i];
    }
    mx = mx/num;
    my = my/num;

    float numer = 0, denom = 0;
    for (i=0; i<num; i++) {
	numer += (x[i] - mx)*(y[i] - my);
	denom += (x[i] - mx)*(x[i] - mx);
    }
    *beta = numer/denom;
    *offset = my - (*beta)*mx;

    float sigma = 0.0;
    for (i=0; i<num; i++) {
	float ecap = (y[i] - my) - (*beta)*(x[i] - mx);
	sigma += ecap*ecap;
    }
    sigma = sigma/(num - 1);
    denom = 0;
    for (i=0; i<num; i++)
	denom += (x[i] - mx)*(x[i] - mx);
    *stderror = sqrt(sigma/denom);
}

float ranf()
{
    return ((float)(random() % 100000))/100000.0;
}

float gauss_draw(float mean, float stddev)
{
    float x1, x2, w, y1, y2;
 
    do {
	x1 = 2.0 * ranf() - 1.0;
	x2 = 2.0 * ranf() - 1.0;
	w = x1 * x1 + x2 * x2;
    } while (w >= 1.0);

    w = sqrt((-2.0 * log(w))/w);
    y1 = x1 * w;
    y2 = x2 * w;
    return (y1*stddev) + mean;
}


int main(int argc, char **argv)
{
    float y[] = {24.3457031, 24.0957031, 24.3457031, 24.3457031, 24.2958984};
    float x[] = {1, 2, 3, 4, 5};
    float beta, offset, error;
    LSE(y, x, 5, &beta, &offset, &error);
    printf("beta: %f stderror: %f\n", beta, error);

    for (int i=0; i<10; i++)
	printf("%f\n", gauss_draw(beta, error));
}
